//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class tabbedforumsindex_hook_tabbedTemplate extends _HOOK_CLASS_
{
	/**
	 * Manage
	 *
	 * @return	void
	 */
	protected function manage()
	{
		try
		{
			parent::manage();
	
			if( \IPS\Settings::i()->forums_default_view_choose )
			{
				if( \IPS\forums\Forum::getMemberView() == 'tabs' AND \count( \IPS\tabbedforumsindex\Tab::roots( NULL, NULL, array( 'tab_active=?', 1 ) ) ) )
				{
					$this->newIndex();
				}
				else
				{
					return parent::manage();
				}
			}
			else
			{
				if( \IPS\Settings::i()->forums_default_view == 'tabs' AND \count( \IPS\tabbedforumsindex\Tab::roots( NULL, NULL, array( 'tab_active=?', 1 ) ) ) )
				{
					$this->newIndex();
				}
				else
				{
					return parent::manage();
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function newIndex()
	{
		try
		{
			$tabs  = \IPS\tabbedforumsindex\Tab::roots( NULL, NULL, array( 'tab_active=?', 1 ) );
			$first = reset( $tabs );
	
			if( $first->type == 'all' )
			{
				foreach( \IPS\forums\Forum::roots() as $category )
				{
					\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabbedTemplate( $category );
					break;
				}
			}
			else
			{
				$category = NULL;
				\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabbedTemplate( $category );
			}
	
			\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'forums' );
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}


	public function getCategoryData()
	{
		try
		{
			if( \IPS\Request::i()->fid == 'clubs' AND \IPS\Settings::i()->club_nodes_in_apps )
			{
				$tab 		= \IPS\tabbedforumsindex\Tab::load( \IPS\Request::i()->tab );
				$forums 	= \IPS\forums\Forum::clubNodes();
				$clubForums = array();
	
				foreach( $forums as $forum )
				{
					if( \in_array( $forum->id, explode( ',', $tab->source_ids ) ) )
					{
						$clubForums[] = $forum;
					}
				}
				$output = \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabsClub( $clubForums, $tab );
			}
			else if( \IPS\Request::i()->fid == 'forums' )
			{
				$tab 	 = \IPS\tabbedforumsindex\Tab::load( \IPS\Request::i()->tab );
				$where 	 = array( array( 'password IS NULL' ) );
				$where[] = array( 'sub_can_post=1' );
				$where[] = array( 'redirect_on=?', 0 );
				$where[] = array( 'club_id IS NULL' );
	
				$forumsToShow = array();
	
				$forums = \IPS\Db::i()->select( "*", 'forums_forums', $where, 'position ASC' );
				foreach( $forums as $forum )
				{
					$forum = \IPS\forums\Forum::constructFromData( $forum );
					if( \in_array( $forum->id, explode( ',', $tab->source_ids ) ) AND $forum->can( 'view', \IPS\Member::loggedIn() ) )
					{
						$forumsToShow[] = $forum;
					}
				}
				$output = \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabsClub( $forumsToShow, $tab );
			}
			else if( \IPS\Request::i()->fid == 'categories' )
			{
				$tab    = \IPS\tabbedforumsindex\Tab::load( \IPS\Request::i()->tab );
				$output = \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabsCategories( $tab );
			}
			else
			{
				try
				{
					$tab    	= \IPS\tabbedforumsindex\Tab::load( \IPS\Request::i()->tab );
					$category 	= \IPS\forums\Forum::load( \IPS\Request::i()->fid );
					$output 	= \IPS\Theme::i()->getTemplate( 'index', 'tabbedforumsindex', 'front' )->tabs( $category, $tab );
				}
				catch ( \OutOfRangeException $e )
				{
					\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=index' ) );
				}
			}
	
			if( \IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->sendOutput( $output );
			}
			else
			{
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=index' ) );
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}